Description

=begin

When a reference on a local object is sent back by a client to a server, it may not be recognised as a local object during marshalling:

An object instance being sent as a reference is wrapped in a DRbObject built by make_proxy with DRbObject.new(obj); the

DRbObject's uri will be the uri returned by DRb::uri.

When this reference is sent back, DRbObject::_load checks if it matches uri of current server with DRb::here? method.

The problem is that DRb.here? checks that a DRbObject uri is the same as the uri which was used by current DRbServer at his

creation, while DRb.uri will return an uri created from the local socket from current thread's connection.

So, when a DRbObject it sent back, it may not be recognized as referencing a local object

Fixing DRb.here? so that it compares with the uri returned by DRb.uri should be enough to quick fix this problem, and seems safe to

me.

(I call it a quick fix because I am sure that even with this change, it is possible to build some less realistics cases with the same kind

of problem, due to the fact that a same reference may be valid or not depending which client sent it back ...)

Here is a very simple proof of concept:

The server:

#!/usr/bin/ruby

require 'drb'

class A

include DRb::DRbUndumped

end

class TheServer

include DRb::DRbUndumped

def initialize

@a = A.new

end

def get_a

@a

end

def is_a(iA)

puts "inside is_a: current DRb.uri:#{DRb.uri}; iA.class = #{iA.class} #{iA.__drburi if DRb::DRbObject === iA}"

@a.eql? iA

end

def getToken

retVal = @@token.clone

@@token.inc

return retVal

end

end

theServer = TheServer.new

DRb.start_service(nil,theServer)

puts "DRb.uri just after start_service: #{DRb.uri}"
DRb.thread.join

#############

The client:

#!/usr/bin/ruby

require 'drb'

theServer = DRb::DRbObject.new(nil,ARGV.shift)

a = theServer.get_a

puts "a.__drburi == #{a.__drburi}"

puts "theServer.is_a(a) == #{theServer.is_a(a)}"

#############

the outputs:

server side:

DRb.uri just after start_service: druby://Venus:60106

inside is_a: current DRb.uri:druby://127.0.0.1:60106; iA.class = DRb::DRbObject druby://127.0.0.1:60106

client side:

a.__drburi == druby://127.0.0.1:60106

theServer.is_a(a) == false

Cheers,

Nicolas

=end

Associated revisions

Revision 190bc7ae - 06/27/2011 03:18 PM - Masatoshi SEKI 

fix [Bug #4409]. add DRbServer#here?

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@32254 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 78a7866e - 08/11/2011 12:37 AM - yugui (Yuki Sonoda)

merges r32254 from trunk into ruby_1_9_2.

fix [Bug #4409]. add DRbServer#here?

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_1_9_2@32912 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 06/26/2011 05:54 PM - naruse (Yui NARUSE)

- Status changed from Open to Assigned

- Assignee set to seki (Masatoshi Seki)

#2 - 06/26/2011 06:41 PM - nahi (Hiroshi Nakamura)

- Target version set to 1.9.3

#3 - 06/28/2011 12:18 AM - seki (Masatoshi Seki)

- Status changed from Assigned to Closed

- % Done changed from 0 to 100

This issue was solved with changeset r32254.

Nicolas, thank you for reporting this issue.

Your contribution to Ruby is greatly appreciated.

May Ruby be with you.

fix [Bug #4409]. add DRbServer#here?

#4 - 11/28/2011 07:23 PM - iamcory (Cory Banks)
Nicolas, thank you for reporting this issue - http://roofracksforvan.com
